// (C) Copyright Cryolite 2005.
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#if !defined(CRY_LAMBDA_ENABLE_SIG_HPP_INCLUDE_GUARD)
#define CRY_LAMBDA_ENABLE_SIG_HPP_INCLUDE_GUARD

#include <boost/utility/result_of.hpp>
#include <boost/tuple/tuple.hpp>


namespace cry{ namespace lambda{

struct enable_sig
{
private:
  template<class FArgs, int arity>
  struct sig_impl;

  template<class FArgs>
  struct sig_impl<FArgs, 1>
    : public boost::result_of<
        typename boost::tuples::element<0, FArgs>::type()
      >
  { };

  template<class FArgs>
  struct sig_impl<FArgs, 2>
    : public boost::result_of<
        typename boost::tuples::element<0, FArgs>::type(
          typename boost::tuples::element<1, FArgs>::type &
        )
      >
  { };

  template<class FArgs>
  struct sig_impl<FArgs, 3>
    : public boost::result_of<
        typename boost::tuples::element<0, FArgs>::type(
          typename boost::tuples::element<1, FArgs>::type &
        , typename boost::tuples::element<2, FArgs>::type &
        )
      >
  { };
  
  template<class FArgs>
  struct sig_impl<FArgs, 4>
    : public boost::result_of<
        typename boost::tuples::element<0, FArgs>::type(
          typename boost::tuples::element<1, FArgs>::type &
        , typename boost::tuples::element<2, FArgs>::type &
        , typename boost::tuples::element<3, FArgs>::type &
        )
      >
  { };
  
  template<class FArgs>
  struct sig_impl<FArgs, 5>
    : public boost::result_of<
        typename boost::tuples::element<0, FArgs>::type(
          typename boost::tuples::element<1, FArgs>::type &
        , typename boost::tuples::element<2, FArgs>::type &
        , typename boost::tuples::element<3, FArgs>::type &
        , typename boost::tuples::element<4, FArgs>::type &
        )
      >
  { };
  
  template<class FArgs>
  struct sig_impl<FArgs, 6>
    : public boost::result_of<
        typename boost::tuples::element<0, FArgs>::type(
          typename boost::tuples::element<1, FArgs>::type &
        , typename boost::tuples::element<2, FArgs>::type &
        , typename boost::tuples::element<3, FArgs>::type &
        , typename boost::tuples::element<4, FArgs>::type &
        , typename boost::tuples::element<5, FArgs>::type &
        )
      >
  { };

public:
  template<class FArgs>
  struct sig
    : sig_impl<FArgs, boost::tuples::length<FArgs>::value>
  { };
}; // struct enable_sig

}} // namespace cry::lambda


#endif // !defined(CRY_LAMBDA_ENABLE_SIG_HPP_INCLUDE_GUARD)
