// (C) Copyright Cryolite 2004.
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)
//
// This header provides specializations of 'boost::result_of' for
// 'boost::lambda::lambda_functor.'
#ifndef CRY_LAMBDA_LAMBDA_HPP_INCLUDE_GUARD
#define CRY_LAMBDA_LAMBDA_HPP_INCLUDE_GUARD

#include <boost/config.hpp>
#include <boost/preprocessor/enum.hpp>
#include <boost/preprocessor/repeat.hpp>
#include <boost/utility/result_of.hpp>

#if defined(BOOST_MSVC)
#pragma warning(push)
#pragma warning(disable:4180)
#pragma warning(disable:4512)
#endif
#include <boost/lambda/lambda.hpp>
#if defined(BOOST_MSVC)
#pragma warning(pop)
#endif


namespace boost{

#define CRY_LAMBDA_SPECIALIZE_RESULT_OF_FOR_LAMBDA(Z, ARITY, _)  \
template<                                                         \
  class T                                                         \
  BOOST_PP_ENUM_TRAILING_BINARY_PARAMS(                           \
    ARITY, class BOOST_PP_INTERCEPT, A                            \
  )                                                               \
>                                                                 \
struct result_of<                                                 \
  lambda::lambda_functor<T>(BOOST_PP_ENUM_PARAMS(ARITY, A))       \
>                                                                 \
{                                                                 \
  typedef typename lambda::lambda_functor<T>::template sig<       \
      tuple<                                                      \
        lambda::lambda_functor<T>                                 \
        BOOST_PP_ENUM_TRAILING_PARAMS(ARITY, A)                   \
      >                                                           \
    >::type type;                                                 \
};

BOOST_PP_REPEAT(10, CRY_LAMBDA_SPECIALIZE_RESULT_OF_FOR_LAMBDA, _)

#undef CRY_LAMBDA_SPECIALIZE_RESULT_OF_FOR_LAMBDA

} // namespace boost


#endif // CRY_LAMBDA_LAMBDA_HPP_INCLUDE_GUARD
