// (C) Copyright Cryolite 2005.
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#if !defined(CRY_UTILITY_ENABLE_IF_MOVABLE_HPP_INCLUDE_GUARD)
#define CRY_UTILITY_ENABLE_IF_MOVABLE_HPP_INCLUDE_GUARD

#include <boost/move.hpp>
#include <boost/utility/enable_if.hpp>
#include <cry/mpl/dependent_identity.hpp>


namespace cry{

template<class T, class DependentType = void, class R = void>
struct enable_if_movable
  : public boost::enable_if<
      boost::is_movable<
        typename cry::mpl::dependent_identity<T, DependentType>::type
      >
    , R
    >
{};

template<class T, class DependentType = void, class R = void>
struct disable_if_movable
  : public boost::disable_if<
      boost::is_movable<
        typename cry::mpl::dependent_identity<T, DependentType>::type
      >
    , R
    >
{};

} // namespace cry


#endif // !defined(CRY_UTILITY_ENABLE_IF_MOVABLE_HPP_INCLUDE_GUARD)
