// (C) Copyright Cryolite 2005.
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#if !defined(CRY_RANDOM_CRAND_HPP_INCLUDE_GUARD)
#define CRY_RANDOM_CRAND_HPP_INCLUDE_GUARD

#include <cstdlib>


namespace cry{

class crand
{
public:
  typedef int result_type;
  
  static bool const has_fixed_range = true;
  static int const min_value = 0;
  static int const max_value = RAND_MAX;

  crand()
  {}

  explicit crand(int n)
  {
    std::srand(n);
  }

  void seed(int n)
  {
    std::srand(n);
  }
  
  int min() const
  {
    return min_value;
  }

  int max() const
  {
    return max_value;
  }

  int operator()()
  {
    return std::rand();
  }

  static bool validation(crand &)
  {
    return true;
  }
}; // class crand

} // namespace cry


#endif // !defined(CRY_RANDOM_CRAND_HPP_INCLUDE_GUARD)
