// (C) Copyright Cryolite 2005.
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#if !defined(CRY_RANGE_INSERT_TO_CONTAINER_HPP_INCLUDE_GUARD)
#define CRY_RANGE_INSERT_TO_CONTAINER_HPP_INCLUDE_GUARD

#include <boost/range/begin.hpp>
#include <cry/range/end.hpp>


namespace cry{ namespace range{

// Default hook point.
template<class SinglePassRange, class Container, class Iterator>
void range_insert_to_container(
  SinglePassRange const &r, Container &c, Iterator const &position
)
{
  c.insert(position, boost::begin(r), boost::end(r));
}

template<class SinglePassRange, class Container, class Iterator>
void insert_to_container(
  SinglePassRange const &r, Container &c, Iterator const &position
)
{
  range_insert_to_container(r, c, position);
}

}} // namespace cry::range


#endif // !defined(CRY_RANGE_INSERT_TO_CONTAINER_HPP_INCLUDE_GUARD)
