// (C) Copyright Cryolite 2005.
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#if !defined(CRY_RANGE_VALUE_TYPE_HPP_INCLUDE_GUARD)
#define CRY_RANGE_VALUE_TYPE_HPP_INCLUDE_GUARD

#include <cstddef>
#include <utility>
#include <boost/range/value_type.hpp>
#include <cry/introspection/has_value_type_mt.hpp>


namespace cry{ namespace range{

template<class T, class = void>
struct value
{};

template<class Container>
struct value<
  Container
, typename cry::has_value_type_mt<Container>::type
>
  : public boost::range_value<Container>
{};

template<class Iterator>
struct value<
  std::pair<Iterator, Iterator>
, void
>
  : public boost::range_value<std::pair<Iterator, Iterator> >
{};

template<class Iterator>
struct value<
  std::pair<Iterator, Iterator> const
, void
>
  : public boost::range_value<std::pair<Iterator, Iterator> const>
{};

template<class T, std::size_t sz>
struct value<
  T[sz]
, void
>
  : public boost::range_value<T[sz]>
{};

template<class T, std::size_t sz>
struct value<
  T const[sz]
, void
>
  : public boost::range_value<T const[sz]>
{};

template<>
struct value<
  char *
, void
>
  : public boost::range_value<char *>
{};

template<>
struct value<
  wchar_t *
, void
>
  : public boost::range_value<wchar_t *>
{};

template<>
struct value<
  char const *
, void
>
  : public boost::range_value<char const *>
{};

template<>
struct value<
  wchar_t const *
, void
>
  : public boost::range_value<wchar_t const *>
{};

}} // namespace cry::range


#endif // !defined(CRY_RANGE_VALUE_TYPE_HPP_INCLUDE_GUARD)
