// (C) Copyright Cryolite 2004, 2005.
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

// CONSIDER: What is "top-level qualification?"
//           See the description in "is_const.hpp."

#if !defined(CRY_TYPE_TRAITS_ADD_CONST_HPP_INCLUDE_GUARD)
#define CRY_TYPE_TRAITS_ADD_CONST_HPP_INCLUDE_GUARD

#include <boost/type_traits/add_const.hpp>


namespace cry{

template<class T>
struct add_const
  : public boost::add_const<T>
{ };

template<class T, int sz>
struct add_const<T [sz]>
{
  typedef T const type[sz];
};

} // namespace cry


#endif // !defined(CRY_TYPE_TRAITS_ADD_CONST_HPP_INCLUDE_GUARD)
