// (C) Copyright Cryolite 2004.
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#if !defined(CRY_TYPE_TRAITS_FUNCTION_TRAITS_HPP_INCLUDE_GUARD)
#define CRY_TYPE_TRAITS_FUNCTION_TRAITS_HPP_INCLUDE_GUARD

#include <boost/type_traits/function_traits.hpp>


namespace cry{

template<class F>
struct arity
{
  BOOST_STATIC_CONSTANT(int, value = boost::function_traits<F>::arity);
  typedef boost::mpl::bool_<value> type;
};

template<class F>
struct arg1
{
  typedef typename boost::function_traits<F>::arg1_type type;
};

template<class F>
struct arg2
{
  typedef typename boost::function_traits<F>::arg2_type type;
};

template<class F>
struct arg3
{
  typedef typename boost::function_traits<F>::arg3_type type;
};

template<class F>
struct arg4
{
  typedef typename boost::function_traits<F>::arg4_type type;
};

template<class F>
struct arg5
{
  typedef typename boost::function_traits<F>::arg5_type type;
};

template<class F>
struct arg6
{
  typedef typename boost::function_traits<F>::arg6_type type;
};

template<class F>
struct arg7
{
  typedef typename boost::function_traits<F>::arg7_type type;
};

template<class F>
struct arg8
{
  typedef typename boost::function_traits<F>::arg8_type type;
};

template<class F>
struct arg9
{
  typedef typename boost::function_traits<F>::arg9_type type;
};

template<class F>
struct arg10
{
  typedef typename boost::function_traits<F>::arg10_type type;
};

} // namespace cry


#endif // !defined(CRY_TYPE_TRAITS_FUNCTION_TRAITS_HPP_INCLUDE_GUARD)
