// (C) Copyright Cryolite 2004.
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#if !defined(CRY_TYPE_TRAITS_IS_INCOMPLETE_ARRAY_HPP_INCLUDE_GUARD)
#define CRY_TYPE_TRAITS_IS_INCOMPLETE_ARRAY_HPP_INCLUDE_GUARD

#include <boost/mpl/bool.hpp>
#include <boost/type_traits/is_same.hpp>
#include <boost/type_traits/is_array.hpp>
#include <boost/type_traits/remove_bounds.hpp>


namespace cry{

namespace type_traits_detail{

template<class T, bool is_array>
struct is_incomplete_array_impl
  : public boost::mpl::false_
{};

template<class T>
struct is_incomplete_array_impl<T, true /* = is_array */>
  : public boost::is_same<T, typename boost::remove_bounds<T>::type[]>
{};

} // namespace type_traits_detail

template<class T>
struct is_incomplete_array
  : public type_traits_detail::is_incomplete_array_impl<
      T, boost::is_array<T>::value
    >
{};

} // namespace cry


#endif // !defined(CRY_TYPE_TRAITS_IS_INCOMPLETE_ARRAY_HPP_INCLUDE_GUARD)
