// (C) Copyright Cryolite 2004.
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#if !defined(CRY_TYPE_TRAITS_PLAIN_HPP_INCLUDE_GUARD)
#define CRY_TYPE_TRAITS_PLAIN_HPP_INCLUDE_GUARD

#include <boost/type_traits/remove_reference.hpp>
#include <boost/type_traits/remove_cv.hpp>


namespace cry{

template<class T>
struct plain
  : public boost::remove_cv<typename boost::remove_reference<T>::type>
{ };

template<class MetaFunction>
struct lazy_plain
{
  typedef typename plain<typename MetaFunction::type>::type type;
};

} // namespace cry


#endif // !defined(CRY_TYPE_TRAITS_PLAIN_HPP_INCLUDE_GUARD)
