// (C) Copyright Cryolite 2004.
// Distributed under the Boost Software License, Version 1.0.
// (See accompanying file LICENSE_1_0.txt or copy at
// http://www.boost.org/LICENSE_1_0.txt)

#if !defined(CRY_UTILITY_ENABLE_IF_SAME_HPP_INCLUDE_GUARD)
#define CRY_UTILITY_ENABLE_IF_SAME_HPP_INCLUDE_GUARD

#include <boost/type_traits/is_same.hpp>
#include <boost/utility/enable_if.hpp>

namespace cry{

template<class T, class U, class R = void>
struct enable_if_same
  : public boost::enable_if<boost::is_same<T, U>, R>
{ };

template<class T, class U, class R = void>
struct disable_if_same
  : public boost::disable_if<boost::is_same<T, U>, R>
{ };

} // namespace cry

#endif // !defined(CRY_UTILITY_ENABLE_IF_SAME_HPP_INCLUDE_GUARD)
